/*
 * Segment 2 (KEx), SWE LMS-TIC3
 * Copyright (C) 2016 BitCtrl Systems GmbH 
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.kex.lmstic3.vew.daten.tic;

import de.bsvrz.dav.daf.main.Data;

/**
 * Repr&auml;sentiert ein mehrwertiges TIC3-Infoelement.
 *
 * @author BitCtrl Systems GmbH, Gieseler
 * @version $Id: TIC3Zustand.java 63650 2016-09-22 17:11:32Z gieseler $    
 */

public class TIC3Zustand extends TMCInteger {

	/**
	 * Erzeugt ein neues Objekt.
	 *
	 * @param xmlName
	 *            Name des XML-ELementes
	 * @param davName
	 *            Name des DAV-Attributes
	 */
	public TIC3Zustand(final String xmlName, final String davName) {
		super(xmlName, davName);
	}

	@Override
	public void setDavDaten(final Data davdata) throws TIC3Exception {
		if (davdata.isPlain()) {
			davdata.asUnscaledValue().set(getWert());
		} else {
			davdata.getUnscaledValue(getDavAttributName()).set(getWert());

			if (!davdata.getUnscaledValue(getDavAttributName()).isState()) {
				throw new TIC3Exception("Der Wert '" + getWert() + "' für das Attribut '" + getDavAttributName()
				+ "' kann nicht auf einen Zustand abgebildet werden");
			}
		}
	}
}
